Index: documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 28635)
+++ documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 28664)
@@ -507,5 +507,5 @@
 </Title>
 <SampleFiles folder="simple_html"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -524,5 +524,5 @@
   <MajorVersion number="3">
     <Menu>
-      <Text id="0255c">Start &rarr; All Programs &rarr; Greenstone-3.05 &rarr; Greenstone Librarian Interface (GLI)</Text>
+      <Text id="0255c">Start &rarr; All Programs &rarr; Greenstone-3.06 &rarr; Greenstone Librarian Interface (GLI)</Text>
     </Menu>
   </MajorVersion>
@@ -615,5 +615,5 @@
 </Title>
 <SampleFiles folder="images"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -813,5 +813,5 @@
 </Title>
 <SampleFiles folder="Word_and_PDF"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -922,5 +922,5 @@
 </Title>
 <Prerequisite id="word_pdf_collection"/>
-<Version initial="2.70w" current="2.86|3.05"/>
+<Version initial="2.70w" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -1185,5 +1185,5 @@
 <SampleFiles folder="pdfbox"/>
 <Prerequisite id="word_pdf_collection"/>
-<Version initial="2.85" current="2.86|3.05"/>
+<Version initial="2.85" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -1228,5 +1228,5 @@
 </Title>
 <SampleFiles folder="Word_and_PDF"/>
-<Version initial="2.70" current="2.86|3.05"/>
+<Version initial="2.70" current="2.86|3.06"/>
 <Content>
 <Text id="ep-2">Greenstone converts PDF files to HTML using third-party software: <AutoText text="pdftohtml.pl" type="italics"/>. This lets users view these documents even if they don't have the PDF software installed. Unfortunately, sometimes the formatting of the resulting HTML files is not so good. This exercise explores some extra options to the PDF plugin which may produce a nicer version for display.</Text>
@@ -1422,5 +1422,5 @@
 <Text id="ew-a">Enhanced Word document handling</Text>
 </Title>
-<Version initial="2.70w" current="2.86|3.05"/>
+<Version initial="2.70w" current="2.86|3.06"/>
 <Prerequisite id="word_pdf_collection"/>
 <Content>
@@ -1546,5 +1546,5 @@
 </Title>
 <Prerequisite id="word_pdf_collection"/>
-<Version initial="2.85" current="2.86|3.05"/>
+<Version initial="2.85" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -1733,5 +1733,5 @@
 </Title>
 <SampleFiles folder="tudor"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -1795,5 +1795,5 @@
 </Title>
 <Prerequisite id="large_html_collection"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -1901,5 +1901,5 @@
 </Title>
 <Prerequisite id="large_html_collection"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <NumberedItem>
@@ -2196,5 +2196,5 @@
 <Text id="st-1">Section tagging for HTML documents</Text>
 </Title>
-<Version initial="2.70w" current="2.86|3.05"/>
+<Version initial="2.70w" current="2.86|3.06"/>
 <Content>
 <NumberedItem>
@@ -2272,5 +2272,5 @@
 <Text id="0411">Downloading files from the web</Text>
 </Title>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -2314,5 +2314,5 @@
 </Title>
 <Prerequisite id="downloading_from_internet"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <NumberedItem>
@@ -2363,5 +2363,5 @@
 </Title>
 <SampleFiles folder="marc"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -2635,5 +2635,5 @@
 </Title>
 <SampleFiles folder="isis"/>
-<Version initial="2.70w" current="2.86|3.05"/>
+<Version initial="2.70w" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -2973,5 +2973,5 @@
 </Title>
 <SampleFiles folder="custom"/>
-<Version initial="3.05" current="3.05"/>
+<Version initial="3.05" current="3.06"/>
 <Content>
 <Comment>
@@ -2982,5 +2982,5 @@
 </Heading>
 <NumberedItem>
-<Text id="themes-3">Enter your Greenstone Library. ( Go to <Path>Start &rarr; All Programs &rarr; Greenstone-3.05 &rarr; Greenstone3 Server</Path> and click <AutoText text="Enter Library"/>.)</Text>
+<Text id="themes-3">Enter your Greenstone Library. ( Go to <Path>Start &rarr; All Programs &rarr; Greenstone-3.06 &rarr; Greenstone3 Server</Path> and click <AutoText text="Enter Library"/>.)</Text>
 </NumberedItem>
 <NumberedItem>
@@ -3102,5 +3102,5 @@
 <SampleFiles folder="custom"/>
 <Prerequisite id="using_themes"/>
-<Version initial="3.05" current="3.05"/>
+<Version initial="3.05" current="3.06"/>
 <Content>
 <Comment>
@@ -3182,5 +3182,5 @@
 </Title>
 <SampleFiles folder="beatles"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <NumberedItem>
@@ -3231,5 +3231,5 @@
 <Prerequisite id="multimedia_collection_explore"/>
 <SampleFiles folder="beatles"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -3760,5 +3760,5 @@
 </Title>
 <SampleFiles folder="niupepa"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -4100,5 +4100,5 @@
 <SampleFiles folder="niupepa"/>
 <Prerequisite id="scanned_image_collection"/>
-<Version initial="2.70" current="2.86|3.05"/>
+<Version initial="2.70" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -4231,5 +4231,5 @@
 </Title>
 <SampleFiles folder="oai"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -4420,5 +4420,5 @@
 </Title>
 <Prerequisite id="simple_image_collection"/>
-<Version initial="2.85" current="2.86|3.05"/>
+<Version initial="2.85" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -4550,5 +4550,5 @@
 </Title>
 <Prerequisite id="GS_OAI_server"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -4798,5 +4798,5 @@
 </Title>
 <Prerequisite id="dspace_to_greenstone"/>
-<Version initial="2.60" current="2.86|3.05"/>
+<Version initial="2.60" current="2.86|3.06"/>
 <Content>
 <Comment>
@@ -4848,5 +4848,5 @@
 <Text id="gems-1">Editing metadata sets</Text>
 </Title>
-<Version initial="2.70w" current="2.86|3.05"/>
+<Version initial="2.70w" current="2.86|3.06"/>
 <Content>
 <Text id="gems-2">GEMS (Greenstone Editor for Metadata Sets) can be used to modify existing metadata sets or create new ones. GEMS is launched from the Librarian Interface when you want to create a new metadata set, or edit an existing one. In this exercise, we run GEMS outside of the Librarian Interface.</Text>
@@ -4856,5 +4856,5 @@
 <NumberedItem>
 <Text id="gems-4">Start the Greenstone Editor for Metadata Sets (GEMS)</Text>
-<Text id="gems-5"><MajorVersion number="2"><Menu>Start &rarr; All Programs &rarr; Greenstone-2.86 &rarr; Metadata Set Editor (GEMS)</Menu></MajorVersion><MajorVersion number="3"><Menu>Start &rarr; All Programs &rarr; Greenstone-3.05 &rarr; Greenstone Editor for Metadata Sets (GEMS)</Menu></MajorVersion></Text>
+<Text id="gems-5"><MajorVersion number="2"><Menu>Start &rarr; All Programs &rarr; Greenstone-2.86 &rarr; Metadata Set Editor (GEMS)</Menu></MajorVersion><MajorVersion number="3"><Menu>Start &rarr; All Programs &rarr; Greenstone-3.06 &rarr; Greenstone Editor for Metadata Sets (GEMS)</Menu></MajorVersion></Text>
 <Text id="gems-5a">(If you're on Linux, use a terminal to run the <Command>gli/gems.sh</Command> start-up script.) </Text>
 </NumberedItem>
@@ -4890,5 +4890,5 @@
 </Title>
 <MajorVersion number="2"><SampleFiles folder="demo"/></MajorVersion>
-<Version initial="2.70w" current="2.86|3.05"/>
+<Version initial="2.70w" current="2.86|3.06"/>
 <Content>
 <Text id="indexers-2">Greenstone supports three indexers <b>MG</b>, <b>MGPP</b> and <b>Lucene</b>. </Text>