Index: gs2-extensions/apache-jena/trunk/src/packages/CASCADE-MAKE/FUSEKI.sh
===================================================================
--- gs2-extensions/apache-jena/trunk/src/packages/CASCADE-MAKE/FUSEKI.sh	(revision 28677)
+++ gs2-extensions/apache-jena/trunk/src/packages/CASCADE-MAKE/FUSEKI.sh	(revision 28682)
@@ -8,5 +8,5 @@
 source ../cascade-make/lib/cascade-lib.bash GEXT_JENA ../.. $*
 
-prefix=$GEXT_JENA_INSTALLED
+prefix=$GEXT_JENA # Pure Java, so no need for OS dependant directory
 
 opt_run_untar $force_untar $auto_untar $package $version
@@ -20,10 +20,10 @@
 if [ $install = "1"  ] ; then
 
-  if [ ! -d "$GEXT_JENA_INSTALLED/bin" ] ; then
-    mkdir "$GEXT_JENA_INSTALLED/bin"
+  if [ ! -d "$GEXT_JENA/bin" ] ; then
+    mkdir "$GEXT_JENA/bin"
   fi
 
-  if [ ! -d "$GEXT_JENA_INSTALLED/bin/script" ] ; then
-    mkdir "$GEXT_JENA_INSTALLED/bin/script"
+  if [ ! -d "$GEXT_JENA/bin/script" ] ; then
+    mkdir "$GEXT_JENA/bin/script"
   fi
 
@@ -34,29 +34,29 @@
   echo "===="
   echo "= Installing server-side scripts"
-  /bin/cp fuseki-server $GEXT_JENA_INSTALLED/bin/script/.
-  chmod a+rx $GEXT_JENA_INSTALLED/bin/script/fuseki-server
-  /bin/cp fuseki-server.bat $GEXT_JENA_INSTALLED/bin/script/.
-  chmod a+rx $GEXT_JENA_INSTALLED/bin/script/fuseki-server.bat
+  /bin/cp fuseki-server $GEXT_JENA/bin/script/.
+  chmod a+rx $GEXT_JENA/bin/script/fuseki-server
+  /bin/cp fuseki-server.bat $GEXT_JENA/bin/script/.
+  chmod a+rx $GEXT_JENA/bin/script/fuseki-server.bat
 
-  /bin/cp fuseki $GEXT_JENA_INSTALLED/bin/script/.
-  chmod a+rx $GEXT_JENA_INSTALLED/bin/script/fuseki
+  /bin/cp fuseki $GEXT_JENA/bin/script/.
+  chmod a+rx $GEXT_JENA/bin/script/fuseki
 
-  /bin/cp fuseki-server.jar $GEXT_JENA_INSTALLED/.
-  chmod a+r $GEXT_JENA_INSTALLED/fuseki-server.jar
+  /bin/cp fuseki-server.jar $GEXT_JENA/.
+  chmod a+r $GEXT_JENA/fuseki-server.jar
 
   echo "= Installing client-side scripts"
-  /bin/cp s-* $GEXT_JENA_INSTALLED/bin/script/.
-  chmod a+rx $GEXT_JENA_INSTALLED/bin/script/s-*
+  /bin/cp s-* $GEXT_JENA/bin/script/.
+  chmod a+rx $GEXT_JENA/bin/script/s-*
 
 
   echo "= Installing configuration files"
-#  /bin/cp config.ttl $GEXT_JENA_INSTALLED/.
-#  chmod a+r $GEXT_JENA_INSTALLED/config.ttl
+#  /bin/cp config.ttl $GEXT_JENA/.
+#  chmod a+r $GEXT_JENA/config.ttl
 
-  /bin/cp -r pages $GEXT_JENA_INSTALLED/etc/.
-  chmod -R a+r $GEXT_JENA_INSTALLED/etc/pages
+  /bin/cp -r pages $GEXT_JENA/etc/.
+  chmod -R a+r $GEXT_JENA/etc/pages
 
-  /bin/cp log4j.properties $GEXT_JENA_INSTALLED/.
-  chmod a+r $GEXT_JENA_INSTALLED/log4j.properties
+  /bin/cp log4j.properties $GEXT_JENA/.
+  chmod a+r $GEXT_JENA/log4j.properties
 
   echo "===="
Index: gs2-extensions/apache-jena/trunk/src/setup.bash
===================================================================
--- gs2-extensions/apache-jena/trunk/src/setup.bash	(revision 28677)
+++ gs2-extensions/apache-jena/trunk/src/setup.bash	(revision 28682)
@@ -25,5 +25,5 @@
 if [ "x$GEXT_JENA" = "x" ] ; then
   export GEXT_JENA=`pwd`
-  export GEXT_JENA_INSTALLED=$GEXT_JENA # Pure Java, so no need for OS dependant directory
+  export GEXT_JENA_INSTALLED=$GEXT_JENA/$GSDLOS 
 
   export FUSEKI_HOME=$GEXT_JENA
@@ -33,16 +33,16 @@
   fi
 
-#  if [ -d "$GEXT_JENA_INSTALLED/bin" ] ; then
-#    export PATH=$GEXT_JENA_INSTALLED/bin:$PATH
-#  fi
+  if [ -d "$GEXT_JENA_INSTALLED/bin" ] ; then
+    export PATH=$GEXT_JENA_INSTALLED/bin:$PATH
+  fi
 
 
-#  if [ -d "$GEXT_JENA/lib" ] ; then
-#    if [ "$GSDLOS" = "linux" ] ; then
-#      export LD_LIBRARY_PATH=$GEXT_JENA/lib:$LD_LIBRARY_PATH
-#    elif [ "$GSDLOS" = "darwin" ] ; then
-#      export DYLD_LIBRARY_PATH=$GEXT_JENA/lib:$DYLD_LIBRARY_PATH
-#    fi
-#  fi
+  if [ -d "$GEXT_JENA/lib" ] ; then
+    if [ "$GSDLOS" = "linux" ] ; then
+      export LD_LIBRARY_PATH=$GEXT_JENA/lib:$LD_LIBRARY_PATH
+    elif [ "$GSDLOS" = "darwin" ] ; then
+      export DYLD_LIBRARY_PATH=$GEXT_JENA/lib:$DYLD_LIBRARY_PATH
+    fi
+  fi
 
   extdir=${GEXT_JENA##*/}